#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

struct point
{
	int x, y;
	point (){}
	point(int x, int y): x(x), y(y) {}
	point(point a, point b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}
	int len()
	{
		return x*x + y*y;
	}
};

vector<pair<point, int> > a;

bool used[22222];
int ans[22222];

int cross(point a, point b)
{
	return a.x * b.y - a.y * b.x;
}

void djarvis()
{
	int n = a.size();
	int mni = 0;
	for(int i = 1; i < n; i++)
	{
		if (a[i].first.x < a[mni].first.x || a[i].first.x == a[mni].first.x && a[i].first.y < a[mni].first.y)
		{
			mni = i;
		}
	}
	while (true) {
		//cout << mni << endl;
		if (used[a[mni].second]) break;
		int v = mni;
		mni = (v + 1);
		if (mni == n) 
			mni = 0;
		for(int i = 0; i < n; i++)
		{
			if (a[v].first.x == a[i].first.x && a[v].first.y == a[i].first.y) {
				used[a[i].second] = true;
				continue;
			}
			if (cross(point(a[v].first, a[mni].first), point(a[v].first, a[i].first)) > 0 || cross(point(a[v].first, a[mni].first), point(a[v].first, a[i].first)) == 0 &&
																							point(a[v].first, a[mni].first).len() > point(a[v].first, a[i].first).len()) {
				mni = i;
			}
		}
	}
}

int main()
{
	int n;
	scanf("%d", &n);
	a.resize(n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d", &a[i].first.x, &a[i].first.y);
		a[i].second = i;
	}
	int k = 1;
	while (a.size() > 0)
	{
		vector<pair<point, int> > cur;
		djarvis();
		int l = 0;
		for(int i = 0; i < a.size(); i++)
		{
			if (used[a[i].second]) {
				ans[a[i].second] = k;
			} else {
				a[l++] = a[i];
			}
		}
		a.resize(l);
		k++;
	}
	for(int i = 0; i < n; i++)
	{
		printf("%d\n", ans[i]);
	}
	return 0;
}