#include <bits/stdc++.h>

using namespace std;

struct point
{
    int x, y, num;
    point(){}
    point(int x, int y): x(x), y(y){}
} g;

point operator - (point a, point b)
{
    return point(a.x - b.x, a.y - b.y);
}

int operator * (point a, point b)
{
    return a.x * b.y - a.y * b.x;
}

bool operator < (point a, point b)
{
    return (a - g) * (b - g) < 0;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    point pt[n];
    for(int i = 0; i < n; i++)
        cin >> pt[i].x >> pt[i].y, pt[i].num = i;
    int ans[n];
    memset(ans, 0, sizeof(ans));
    int sz = n;
    int cnt = 1;
    while(sz)
    {
        for(int i = 1; i < sz; i++)
            if(pt[i].x < pt[0].x) swap(pt[0], pt[i]);
        g = pt[0];
        sort(pt + 1, pt + sz);
        vector<int> st = {0, 1};
        for(int i = 2; i < sz; i++)
        {
            while(st.size() > 1 && pt[i] - pt[st.size() - 2] < pt[st.size() - 1] - pt[st.size() - 2]) st.pop_back();
            st.push_back(i);
        }
        if(sz == 1) st.resize(1);
        for(int it: st) ans[pt[it].num] = cnt;
        int ins = 0;
        for(int i = 0; i < sz; i++)
            if(!ans[pt[i].num])
                pt[ins++] = pt[i];
        sz = ins;
        cnt++;
    }
    for(int it: ans)
        cout << it << "\n";
    return 0;
}
