#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

typedef pii pt;
#define x first
#define y second

pt operator + (const pii &a, const pii &b) {
	return pt(a.x + b.x, a.y + b.y);
}

pt operator - (const pii &a, const pii &b) {
	return pt(a.x - b.x, a.y - b.y);
}

int operator * (const pii &a, const pii &b) {
	return a.x * b.x + a.y * b.y;
}

int operator ^ (const pii &a, const pii &b) {
	return a.x * b.y - a.y * b.x;
}

const int N = 20000;
const int X = 10000;

struct Input {
	int n;
	pt a[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			scanf("%d%d", &a[i].x, &a[i].y);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans[N];
	
	void write () {
		forn (i, n) {
			printf("%d\n", ans[i] + 1);
		}
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	
	void solve () {
		memset(ans, -1, sizeof ans);
		for (int k = 0; 1; ++k) {
			int bst = -1;
			{
				pt mn = mp(X + 1, X + 1);
				forn (i, n) {
					if (ans[i] == -1 && umn(mn, a[i])) {
						bst = i;
					}
				}
			}
			if (bst == -1) {
				return;
			}
			int cur = bst;
			pt lst = mp(0, 1);
			int qqq = cur;
			while (ans[cur] == -1) {
				ans[cur] = k;
				bst = -1;
				{
					pii val = mp(0, -1000000000);
					auto cmp = [&] (const pii &a, const pii &b) -> bool {
						int qa = (a.fs) ? 0 : ((a.sc > 0) ? 1 : -1);
						int qb = (b.fs) ? 0 : ((b.sc > 0) ? 1 : -1);
						if (qa != qb) {
							return qa > qb;
						}
						if (qa == 0) {
							ll qwe = ll(a.fs) * ll(b.sc) - ll(b.fs) * ll(a.sc);
							if (qwe) {
								return qwe > 0;
							}
							return sqr(ll(a.fs)) + sqr(ll(a.sc)) < sqr(ll(b.fs)) + sqr(ll(b.sc));
						}
						return sqr(ll(a.sc)) < sqr(ll(b.sc));
					};
					forn (i, n) {
						if (i != cur && (ans[i] == -1 || i == qqq)) {
							pt v = a[i] - a[cur];
							pii val_ = mp(lst ^ v, lst * v);
							if (cmp(val_, val)) {
								val = val_;
								bst = i;
							}
						}
					}
				}
				if (cur == -1) {
					break;
				}
				lst = a[bst] - a[cur];
				cur = bst;
			}
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("l.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
