#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

struct vt
{
	int x, y;
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y);
	}
	vt(int _x, int _y)
	{
		x = _x, y = _y;
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y);
	}
	friend int operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y;
	}
	friend bool operator <(vt a, vt b)
	{
		return make_pair(a.y, a.x) < make_pair(b.y, b.x);
	}
	friend int operator ^(vt a, vt b)
	{
		return a.x * b.y - b.x * a.y;
	}
	int abs()
	{
		return x * x + y * y;
	}
	vt(){}
};

const int N = 10400;

int num[N];
vector<vt> P, nP;

bool used[N];

vector<int> ind, nind;

void split(int col)
{
	nP.clear();
	for (int i = 0; i < P.size(); i++)
		used[i] = 0;
	if (P.size() <= 2)
	{
		for (int i = 0; i < ind.size(); i++)
			num[ind[i]] = col;
		P.clear();
	}
	else
	{
		int c = min_element(P.begin(), P.end()) - P.begin();
		int c0 = c;
		while (true)
		{
			int mn = -1;
			for (int i = 0; i < P.size(); i++)
			{
				if (i == c)
					continue;
				if (used[i])
					continue;
				if (mn == -1)
					mn = i;
				else
				{
					vt a = P[mn] - P[c];
					vt b = P[i] - P[c];
					
					if (((a ^ b) < 0) || ((a ^ b) == 0 && (a * a) > (b * b)))
						mn = i;
				}
			}
			used[mn] = true;
			if (mn == c0)
				break;
			c = mn;
		}
		nP.clear();
		nind.clear();
		for (int i = 0; i < P.size(); i++)
		{
			if (used[i])
				num[ind[i]] = col;
			else
			{
				nP.push_back(P[i]);
				nind.push_back(ind[i]);
			}
		}
		P = nP;
		ind = nind;
	}
}

int main() {
#ifdef LOCAL42
#define TASK "L"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n; 
	scanf("%d", &n);
	//n = 10000;
	P.resize(n);
	ind.resize(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d %d", &P[i].x, &P[i].y);
		//P[i] = vt(rand(), rand());
		ind[i] = i;
	}
	int c = 0;
	while (!P.empty())
		split(++c);
	for (int i = 0; i < n; i++)
		printf("%d\n", num[i]);
	return 0;
}
