#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 20200;
const int inf = 1<<30;

int ans[N], n, m;

struct pt {
	int x, y, id;

	pt() {}

	pt(int x, int y) : x(x), y(y) {}

	void read() {
		scanf("%d %d", &x, &y);
	}

	pt operator - (pt o) {
		return pt(x - o.x, y - o.y);
	}

	int cross(pt o) {
		return x * o.y - y * o.x;
	}

	int dot(pt o) {
		return x * o.x + y * o.y;
	}

	void print() {
		cout << x << " " << y << endl;
	}
} a[N], pivot, b[N];

bool cmp(pt a, pt b) {
	pt v = a - pivot;
	pt u = b - pivot;
	int cross = v.cross(u);
	if (cross != 0) return cross > 0;
	return v.dot(v) <= u.dot(u);
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d", &n); m = n;
	for (int i = 0; i < n; i++) {
		a[i].read();
		a[i].id = i;
	}

	for (int iter = 1;; iter++) {
		if (n <= 3) {
			for (int i = 0; i < n; i++)
				ans[a[i].id] = iter;
			break;
		} else {
			int id = -1;
			for (int i = 0; i < n; i++)
			if (id == -1 || a[i].y < a[id].y || (a[i].y == a[id].y && a[i].x < a[id].x))
				id = i;
			pivot = a[id];
			sort(a, a + n, cmp);
			int m = 0;
			for (int i = 0; i < n; i++) {
				while (m >= 2 && (b[m-1] - b[m-2]).cross(a[i] - b[m-2]) < 0) m--;
				b[m++] = a[i];
			}
			for (int i = 0; i < m; i++)
				ans[b[i].id] = iter;
			m = 0;
			for (int i = 0; i < n; i++)
			if (ans[a[i].id] != iter)
				a[m++] = a[i];
			n = m;
		}
	}

	for (int i = 0; i < m; i++)
		printf("%d\n", ans[i]);

	return 0;
}
