#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef int ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "l"

struct pt
{
	ld x, y;
	int id;
	
	pt(): x(0), y(0) {}
	
	pt(ld x, ld y): x(x), y(y) {}
	
	ld operator*(const pt &a)
	{
		return x * a.y - y * a.x;
	}
	
	ld operator%(const pt &a)
	{
		return x * a.x + y * a.y;
	}
	
	pt operator-(const pt &a) const
	{
		return pt(x - a.x, y - a.y);
	}
	
};

bool cmp(pt a, pt b)
{
	return mp(a.x, a.y) < mp(b.x, b.y);
}

pt a[100004];
pt b[100004];
int ans[100004];

pt up[100004];
pt down[100004];

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		a[i] = pt(x, y);
		a[i].id = i;
	}
	int N = n;
	for (int i = 0; i < n; ++i)
		ans[i] = -1;
	sort(a, a + n, cmp);
	int q = 1;
	while (n)
	{
		int uc = 0, dc = 0;
		for (int i = 0; i < n; ++i)
		{
			pt &c = a[i];
			while (uc > 1)
			{
				if ((c - up[uc - 2]) * (up[uc - 1] - up[uc - 2]) >= 0)
					break;
				--uc;
			}
			while (dc > 1)
			{
				if ((c - down[dc - 2]) * (down[dc - 1] - down[dc - 2]) <= 0)
					break;
				--dc;
			}
			down[dc++] = c;
			up[uc++] = c;
		}
		for (int i = 0; i < dc; ++i)
			ans[down[i].id] = q;
		for (int i = 0; i < uc; ++i)
			ans[up[i].id] = q;
		int m = 0;
		for (int i = 0; i < n; ++i)
			if (ans[a[i].id] == -1)
				b[m++] = a[i];
		for (int i = 0; i < m; ++i)
			a[i] = b[i];
		n = m;
		++q;
	}
	for (int i = 0; i < N; ++i)
		cout << ans[i] << '\n';
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
