#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(), (x).end
#define x first
#define y second

#define in(n) int n = nxt()
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}
long double eps = 1e-8;


struct pt {
    long long x, y, z;
    pt(){}
    pt(long long x, long long y, long long z) : x(x), y(y), z(z) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y, z - r.z);
    }
    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y, z + r.z);
    }

    friend pt vect(const pt &l, const pt &r) {
        return pt(l.y * r.z - l.z * r.y,
                  l.z * r.x - l.x * r.z,
                  l.x * r.y - l.y * r.x);
    }

    friend long long scal(const pt &l, const pt &r) {
        return l.x * r.x + l.y * r.y + l.z * r.z;
    }
};

struct plane {
    pt n, t;
    plane(){}
    plane(const pt &a, const pt &b, const pt &c) {
        n = vect(a - c, b - c);
        t = a;
    }

    long double dist(const pt &c) {
        return abs(scal(c - t, n)) / sqrtl(scal(n, n));
    }
};

void solve(){
    int m = nxt();
    int h = nxt();
    int H = nxt();

    pt a[4];
    pt c;
    c.x = nxt();
    c.y = nxt();
    c.z = h;

    for (int i = 0; i < 4; ++i) {
        a[i].x = nxt();
        a[i].y = nxt();
        a[i].z = 0;
    }
    a[3].z = H;

    if (m < h) {
        cout << "NO\n";
        return;
    }
    m -= h;

    plane pl[4];
    int sz = 0;
    for (int i = 0; i < 4; ++i) {
        for (int j = i + 1; j < 4; ++j) {
            for (int k = j + 1; k < 4; ++k) {
                pl[sz++] = plane(a[i], a[j], a[k]);
            }
        }
    }
    assert(sz == 4);
    long double dist[4];
    for (int i = 0; i < 4; ++i) {
        dist[i] = pl[i].dist(c);
    }
    for (int i = 0; i < 4; ++i) {
        cout << pl[i].n.x << " " << pl[i].n.y << " " << pl[i].n.z << endl;
    }

    for (int i = 0; i < 4; ++i) {
        cout << dist[i] << " ";
    }
    cout << endl;
    cout << m << endl;
    for (int i = 0; i < 4; ++i) {
        if (dist[i] < m + eps) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
