#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(), (x).end
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

const double eps = 1e-9;

struct pt {
    double x, y;
    pt(){}
    pt(double x, double y) : x(x), y(y) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y);
    }
    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y);
    }
    pt operator * (double k) const {
        return pt(x * k, y * k);
    }
    double vect(const pt &l, const pt &r) const {
        return fabs((l.y - y) * (r.x - x) - (r.y - y) * (l.x - x)); //DONT COPY
    }

    void err(){
        cerr << x << " " << y << "\n";
    }
};

int smth(const pt & x, const pt & y, const pt & p){
    double qw = (x.y - p.y) * (y.x - p.x) - (y.y - p.y) * (x.x - p.x);
    if (qw > eps)
        return 1;
    else if (qw < -eps)
        return -1;
    else
        return 0;
}

bool inrt(const pt & x, const pt & y, const pt & a, const pt & b){
    return (smth(x, y, a) * smth(x, y, b) <= 0 && smth(a, b, x) * smth(a, b, y) <= 0);
}

bool intr(const pt & x, const pt & y, const pt & a, const pt & b, const pt & c){
    return (inrt(x, y, a, b) || inrt(x, y, b, c) || inrt(x, y, c, a));
}

bool inside(const pt & p, const pt & a, const pt & b, const pt & c){
    return (fabs(p.vect(a, b) + p.vect(b, c) + p.vect(c, a) - a.vect(b, c)) < eps);
}

bool strinside(const pt & p, const pt & a, const pt & b, const pt & c){
    return (inside(p, a, b, c) && smth(a, b, p) && smth(c, b, p) && smth(a, c, p));
}

void solve(){
    pt a = pt(10, 0);
    pt b = pt(0, 0);
    pt c = pt(10, 10);
    pt zr = pt(0, 0);
    double x, y;
    cin >> x >> y;
    pt p(x, y);
    double qw = 25;
    double ans = 0;
    while (qw > 1e-5){
//        a.err();
//        b.err();
//        c.err();
        pt d = (b + c) * 0.5;
        bool b1 = strinside(p, a, b, d);
        bool b2 = strinside(p, a, c, d);
        if (b1 && b2){
            ans += qw;
            break;
        } else
        if (b1){
            if (intr(zr, p, a, c, d))
                ans += qw;
            qw /= 2;
            c = d;
            swap(a, c);
        } else
        if (b2){
            if (intr(zr, p, a, b, d))
                ans += qw;
            qw /= 2;
            b = d;
            swap(a, b);
        } else {
            if (inside(p, a, b, d) || inside(p, a, c, d))
                ans += qw;
            break;
        }
    }
    cout << setprecision(8) << fixed;
    cout << ans << "\n";
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
