#pragma comment (linker, "/STACK:100000000")
#include <stdio.h>
#include <vector>
using namespace std;
#define N 101000
struct S {
	int p[N], h[N];
	void init(int n) { int i; for (i = 0; i<n; p[i] = i, h[i] = 1, i++); }
	int fnd(int i) { return p[i] = i == p[i] ? i : fnd(p[i]); }
	void uni(int i, int j)
	{
		i = fnd(i); j = fnd(j);
		if (h[i]<h[j]) p[i] = j;
		else if (h[j]<h[i]) p[j] = i;
		else { p[i] = j; h[j]++; }
	}
};
int l1[N], l2[N], bl, u[N], b[N], p[N], c, n;
S d, t;
vector <int> v[N], m[N];
void upd(int i, int j) { if (u[j]<u[l1[i]]) { l2[i] = l1[i]; l1[i] = j; } else if (u[j]<u[l2[i]]) l2[i] = j; }
void back(int i, int j) { for (; d.fnd(i) != d.fnd(j); i = b[d.fnd(i)], u[l2[i]]<u[bl] ? bl = l2[i] : 0, d.uni(i, j), i = p[i]); }
void dfs(int i)
{
	int j, k, l;
	for (u[i] = c++, l1[i] = i, l2[i] = i, j = 0; j<m[i].size(); j++)
	{
		k = m[i][j];
		if (!u[k])
		{
			p[k] = i;
			dfs(k);
			for (bl = i, l = 0; l<v[i].size(); back(v[i][l], i), l++);
			upd(i, l1[k]);
			upd(i, bl);
			v[i].clear();
		}
		else if (u[k]<u[i] && k != p[i]) { upd(i, k); v[k].push_back(i); }
	}
	b[d.fnd(i)] = i;
	t.uni(i, l2[i]);
}
int main()
{
	int i, j, k;
	//freopen("job.in","r",stdin);
	//freopen("job.out","w",stdout);
	scanf("%d%d", &n, &k);
	if ((n<1) || (n>100000)) { fprintf(stderr, "n=%d\n", n); return(239); }
	if ((k<1) || (k>100000)) { fprintf(stderr, "k=%d\n", k); return(239); }
	for (d.init(n), t.init(n), c = 1, i = 0; i<n; m[i].clear(), v[i].clear(), u[i] = 0, i++);
	for (; k; k--)
	{
		scanf("%d%d", &i, &j);
		if ((i<1) || (i>n)) { fprintf(stderr, "i[%d]=%d\n", k, i); return(239); }
		if ((j<1) || (j>n)) { fprintf(stderr, "j[%d]=%d\n", k, j); return(239); }
		if (i == j) { fprintf(stderr, "i[%d]=j[%d]\n", k, k); return(239); }
		i--; j--; m[i].push_back(j); m[j].push_back(i);
	}
	for (i = 0; i<n; i++)
	if (!u[i]) { p[i] = -1; dfs(i); }
	scanf("%d", &k);
	if ((k<0) || (k>100000)) { fprintf(stderr, "q=%d\n", k); return(239); }
	for (; k; k--)
	{
		scanf("%d%d", &i, &j);
		if ((i<1) || (i>n)) { fprintf(stderr, "a[%d]=%d\n", k, i); return(239); }
		if ((j<1) || (j>n)) { fprintf(stderr, "b[%d]=%d\n", k, j); return(239); }
		if (i == j) { fprintf(stderr, "a[%d]=b[%d]\n", k, k); return(239); }
		i--; j--; printf("%s\n", t.fnd(i) == t.fnd(j) ? "Yes" : "No");
	}
	return 0;
}