#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

double m, h, H;
struct Punct{double x, y, z;};
Punct v[5];

double Dist(Punct A, Punct B, Punct C)
{
    double a, b, c, d;
    a = (B.y - A.y) * (C.z - A.z) - (C.y - A.y) * (B.z - A.z);
    b = - (B.x - A.x) * (C.z - A.z) + (C.x - A.x) * (B.z - A.z);
    c = (B.x - A.x) * (C.y - A.y) - (C.x - A.x) * (B.y - A.y);
    d = -(A.x * B.y * C.z + C.x * A.y * B.z + B.x * C.y + A.z - A.z * B.y * C.x - C.z * A.y * B.x - B.z * C.y * A.x);
    return (fabs(a * v[0].x + b * v[0].y + c * v[0].z + d) / sqrt(a * a + b * b + c * c));
}

int main ()
{
#ifdef local
    freopen ("f.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i;
    cin >> m >> h >> H;
    for(i = 0; i <= 4; ++i)
        cin >> v[i].x >> v[i].y;
    double D;
    m -= h;
    v[0].z = h;
    v[1].z = v[2].z = v[3].z = 0.0;
    v[4].z = H;
    D = Dist(v[1], v[2], v[3]);
    D = min(D, Dist(v[1], v[2], v[4]));
    D = min(D, Dist(v[1], v[3], v[4]));
    D = min(D, Dist(v[2], v[3], v[4]));
    m -= D;
    if(m >= -0.00000001)
        cout << "YES\n";
    else
        cout << "NO\n";
    return 0;
}