#include <vector>
#include <algorithm>
#include <iostream>
#include <utility>
#include <cstring>
#include <fstream>
#include <stack>
#include <queue>
#include <set>

#define inf 2000000000
#define maxn 20010

using namespace std;

ifstream fin ("input.txt");
ofstream fout ("output.txt");

struct point
{
    int x,y,i;
}v[maxn];
int s[maxn],n,mark[maxn];

int det (const point &a, const point &b, const point &c)
{
    return (b.x - a.x)*(c.y - a.y) - (b.y - a.y)*(c.x - a.x);
}

bool cmp (point a, point b)
{
    if (a.x == b.x)
      return a.y < b.y;
    return a.x < b.x;
}

int main ()
{
    fin>>n;

    int mini = 1;

    for (int i=1; i<=n; ++i)
    {
        fin>>v[i].x>>v[i].y;
        v[i].i = i;
    }

    sort (v+1,+v+n+1,cmp);

    int cnt = 0;

    for (int h=1; cnt < n; ++h)
    {
        int k = 0;

        for (int i=1; i<=n; ++i)
        {
            if (mark[v[i].i])
              continue;

            while (k >= 2 && det (v[s[k-1]],v[s[k]],v[i]) > 0)
              --k;
            s[++k] = i;
        }

        for (int i=n; i>=1; --i)
        {
            if (mark[v[i].i])
              continue;

            while (k >= 2 && det (v[s[k-1]],v[s[k]],v[i]) > 0)
              --k;
            s[++k] = i;
        }

        for (int i=1; i<=k; ++i)
        {
            if (!mark[v[s[i]].i])
              ++cnt;
            mark[v[s[i]].i] = h;
        }
    }

    for (int i=1; i<=n; ++i)
       fout<<mark[i]<<"\n";
}
